Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ObjectPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ObjectPool.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ObjectPool.cs	(revision 14744)
@@ -0,0 +1,105 @@
+﻿// Licensed to the .NET Foundation under one or more agreements.
+// The .NET Foundation licenses this file to you under the MIT license.
+// See the LICENSE file in the project root for more information.
+
+using System;
+
+namespace TestPooling.Pool {
+  using System.Threading;
+
+  /// <summary>
+  /// Generic implementation of object pooling pattern with predefined pool size limit. The main
+  /// purpose is that limited number of frequently used objects can be kept in the pool for
+  /// further recycling.
+  ///
+  /// Notes:
+  /// 1) it is not the goal to keep all returned objects. Pool is not meant for storage. If there
+  ///    is no space in the pool, extra returned objects will be dropped.
+  ///
+  /// 2) it is implied that if object was obtained from a pool, the caller will return it back in
+  ///    a relatively short time. Keeping checked out objects for long durations is ok, but
+  ///    reduces usefulness of pooling. Just new up your own.
+  ///
+  /// Not returning objects to the pool in not detrimental to the pool's work, but is a bad practice.
+  /// Rationale:
+  ///    If there is no intent for reusing the object, do not use pool - just use "new".
+  /// </summary>
+  public sealed class ObjectPool<T> where T : class {
+    private struct Element {
+      internal T Value;
+    }
+
+    // storage for the pool objects.
+    private readonly Element[] _items;
+
+    // factory is stored for the lifetime of the pool. We will call this only when pool needs to
+    // expand. compared to "new T()", Func gives more flexibility to implementers and faster
+    // than "new T()".
+    private readonly Func<T> _factory;
+
+
+    internal ObjectPool(Func<T> factory)
+        : this(factory, Environment.ProcessorCount * 2) { }
+
+    internal ObjectPool(Func<T> factory, int size) {
+      _factory = factory;
+      _items = new Element[size];
+    }
+
+    private T CreateInstance() {
+      var inst = _factory();
+      return inst;
+    }
+
+    /// <summary>
+    /// Produces an instance.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search.
+    /// </remarks>
+    internal T Allocate() {
+      var items = _items;
+      T inst;
+
+      for (int i = 0; i < items.Length; i++) {
+        // Note that the read is optimistically not synchronized. That is intentional.
+        // We will interlock only when we have a candidate. in a worst case we may miss some
+        // recently returned objects. Not a big deal.
+        inst = items[i].Value;
+        if (inst != null) {
+          if (inst == Interlocked.CompareExchange(ref items[i].Value, null, inst)) {
+            goto gotInstance;
+          }
+        }
+      }
+
+      inst = CreateInstance();
+      gotInstance:
+
+      return inst;
+    }
+
+    /// <summary>
+    /// Returns objects to the pool.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search in Allocate.
+    /// </remarks>
+    internal void Free(T obj) {
+      var items = _items;
+      for (int i = 0; i < items.Length; i++) {
+        if (items[i].Value == null) {
+          // Intentionally not using interlocked here.
+          // In a worst case scenario two objects may be stored into same slot.
+          // It is very unlikely to happen and will only mean that one of the objects will get collected.
+          items[i].Value = obj;
+          break;
+        }
+      }
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs	(revision 14744)
@@ -0,0 +1,127 @@
+﻿using System.Threading.Tasks;
+
+namespace TestPooling {
+  using System;
+  using System.Diagnostics;
+
+  using TestPooling.Pool;
+
+  class Program {
+    private const int Count = 3000;
+    static void Main(string[] args) {
+      Test1();
+      Test1_2();
+      Test3();
+    }
+
+    private static void Test1() {
+      var sw = new Stopwatch();
+
+      sw.Start();
+      //Parallel.For(0, 3, k => {
+      Parallel.For(0, 10000, i => {
+        using (var pool = new ManagedPool<Person>(Count, () => new Person())) {
+          for (var j = 0; j < 3000; j++) {
+            var person = pool.Get();
+            person.Age = i + j;
+            person.Name = string.Format("{0} - {1}", i, j);
+          }
+        }
+      });
+      //});
+      sw.Stop();
+
+      Console.WriteLine("1 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
+    }
+
+    private static void Test1_2() {
+      var sw = new Stopwatch();
+      sw.Start();
+
+      var dummyPartition = new Person[Count];
+
+      for (var i = 0; i < Count; i++) {
+        dummyPartition[i] = new Person();
+      }
+
+      //Parallel.For(0, 3, k => {
+      Parallel.For(0, 10000, i => {
+        using (var pool = new ManagedPool2<Person>(Count, dummyPartition, () => new Person())) {
+          for (var j = 0; j < 3000; j++) {
+            var person = pool.Get();
+            person.Age = i + j;
+            person.Name = string.Format("{0} - {1}", i, j);
+          }
+        }
+      });
+      //});
+      sw.Stop();
+
+      //var p1 = new ManagedPool2<Person>(Count, dummyPartition, () => new TestPooling.Person());
+      //var p2 = new ManagedPool2<Person>(Count, dummyPartition, () => new TestPooling.Person());
+      //var pa1 = p1.Get();
+      //var pa2 = p2.Get();
+
+      Console.WriteLine("1_2 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
+    }
+
+    private static void Test4() {
+      var sw = new Stopwatch();
+
+      sw.Start(); ;
+      var pool = new ManagedPool<Person>(512, () => new Person());
+
+      Parallel.For(0, 10000, i => {
+        for (var j = 0; j < 3000; j++) {
+          var person = pool.Get();
+          person.Age = i + j;
+          person.Name = string.Format("{0} - {1}", i, j);
+        }
+        pool.Dispose();
+      });
+      sw.Stop();
+
+      Console.WriteLine("1 - Duration: {0}", sw.ElapsedTicks);
+    }
+
+    private static void Test3() {
+      var count = 0;
+      var sw = new Stopwatch();
+
+      sw.Start();
+      Parallel.For(0, 10000, i => {
+        var list = new Person[3000];
+
+        for (var j = 0; j < 3000; j++) {
+          list[j] = new Person { Age = i + j, Name = string.Format("{0} - {1}", i, j) };
+        }
+
+        count += list.Length;
+      });
+      sw.Stop();
+
+      Console.WriteLine("3 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
+      Console.WriteLine("Count: {0}", count);
+    }
+
+    private static void Test2() {
+      var pool = new ObjectPool<Person>(() => new Person(), 2048);
+
+      Parallel.For(0, 10000, i => {
+        for (var j = 0; j < 3000; j++) {
+          var person = pool.Allocate();
+          person.Age = i + j;
+          person.Name = string.Format("{0} - {1}", i, j);
+        }
+
+        //pool.Free()
+      });
+    }
+  }
+
+  [Serializable]
+  class Person {
+    public string Name { get; set; }
+    public int Age { get; set; }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Properties/AssemblyInfo.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Properties/AssemblyInfo.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Properties/AssemblyInfo.cs	(revision 14744)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("TestPooling")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("TestPooling")]
+[assembly: AssemblyCopyright("Copyright ©  2017")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("b184a849-1403-4f5f-96f8-952c6599a7c0")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj	(revision 14744)
@@ -0,0 +1,64 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{B184A849-1403-4F5F-96F8-952C6599A7C0}</ProjectGuid>
+    <OutputType>Exe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>TestPooling</RootNamespace>
+    <AssemblyName>TestPooling</AssemblyName>
+    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Pool\ManagedPool.cs" />
+    <Compile Include="Pool\ManagedPool2.cs" />
+    <Compile Include="Pool\ManagedPoolProvider.cs" />
+    <Compile Include="Pool\ObjectPool.cs" />
+    <Compile Include="Program.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="App.config" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
